
% Calculate user density with C=100

function CellInhabitantDensity()

lambda1 = 3/(24*3600);
EDs = 120;
C=100;
Ng=10;

people = 50000:1000:200000;
Pb = zeros(1,length(people));

for p=1:length(people)
   a=people(p)*lambda1*EDs;
   a_h = 0.2*a;
   pi = compute_mmkk_guard_channels( C, a, Ng, a_h );
   Pb(p)=pi(C+1);
end

figure
semilogy(people./0.234,Pb);
hold
semilogy(people./0.234,1E-2.*ones(1,length(people)),'r');
hold
grid

idx = find(Pb < 1E-2)
people(idx(end))/0.234

