clear
clf

lambda_i = 3/(24*3600);
EDs = 120; % service time
C = 20;    % number of channels
Ng = 0:C; % number of guard channels
N = length(Ng);

% high density
a = lambda_i*5000*0.234*EDs; 
a_high = 0.7*a; % high mobility
%a_low = 0.2*a;

Pb = zeros(1,N);
Pd = zeros(1,N);
GoS = zeros(1,N);

% Q4
for i=1:N
    
    pi = compute_mmkk_guard_channels(C,a,Ng(i),a_high);
    
    Pb(i) = sum(pi(C-Ng(i)+1:end));
    Pd(i) = pi(end);
    GoS(i) =  Pb(i) + 10*Pd(i);
end

disp('Number of Guard Channels Minimising the GoS')
[~,Ng_min] = min(GoS); 
disp(Ng_min-1) % elements are indexed by 1,2,.. in Matlab

figure(1)
semilogy(Ng,Pb,'b-+','LineWidth',1);
hold on 
plot(Ng,Pd,'b-o','LineWidth',1);
hold on
plot(Ng,GoS,'b-*','LineWidth',1);
grid on
xlabel('Number of Guard Channels');
legend('Blocking Prob','Dropping Prob','GoS')







