
% Input:
% -- lambda: arrival rate (poisson)
% -- EX: expected service time (expo)
% Output
% -- System delay
% -- Buffer delay
% -- Queue Utilization

function [EDhop]=HopDelay(R,lambda,EL,dprocessing,dpropagation)

% D_hop = dprocessing + dinterface (dbuffer + dtx) + dpropagation

% dinterface = dmm1

EDs = EL / R;

a = lambda * EDs;

mu = 1 / EDs;

if(a >= 1) 
    disp('System is unstable');
    ED = inf;
    EDq = inf;
else
   ED = 1 / (mu - lambda);
   EDq = ED - EDs;
end

rho = a;

EDhop = dprocessing + ED + dpropagation; 

end