
clear 
clc
% %% Ex1
% R = 10E6;
% 
% EL_vc = 800*8;
% EL_wb = 8E3;
% EL_ft = 12E3;
% 
% B_vc = 4E6;
% B_wb = 20E3*8;
% B_ft = 0.9*R;
% 
% lambda_vc = B_vc/EL_vc;
% lambda_wb = B_wb/EL_wb;
% lambda_ft = B_ft/EL_ft;
% 
% EDs_vc = EL_vc/R;
% EDs_wb = EL_wb/R;
% EDs_ft = EL_ft/R;
% 
% a_vs = lambda_vc*EDs_vc
% a_wb = lambda_wb*EDs_wb
% a_ft = lambda_ft*EDs_ft
% 
% K = 100; % buffer size
% 
% [ED_vs,~,~,~] = mm1k(lambda_vc,EDs_vc,K+1)
% [ED_wb,~,~,~] = mm1k(lambda_wb,EDs_wb,K+1)
% [ED_ft,~,~,~] = mm1k(lambda_ft,EDs_ft,K+1)
%D_FT > D_VC > D_WB

%% Ex2
close all

N = 100; % Number of Web Browsing sources

B = 20E3*8;
L = 8E3;
R = 10E6;
K= 100;

lambda = B/L;
EDs = L/R;

ED = zeros(1,N);
EDq = zeros(1,N);
Pb = zeros(1,N);
rho = zeros(1,N);

for i=1:N
   [ED(i),EDq(i),Pb(i),rho(i)]=mm1k(i*lambda,EDs,K); 
end

figure('pos',[400 400 450 300])
axes;
set(gca,'fontsize',12);
semilogy(1:N,ED,'ro-','LineWidth',1.5,'Markersize',4,'Color',[0.2,0.8,0.2]);

h_legend=legend('E[D]');
set(h_legend,'FontSize',12);

xlabel('Number of Web browsing sources','FontSize',12);
ylabel('E[D] (s)','FontSize',12);

figure('pos',[400 400 450 300])
axes;
set(gca,'fontsize',12);
semilogy(1:N,Pb,'ro-','LineWidth',1.5,'Markersize',4);

h_legend=legend('Pb');
set(h_legend,'FontSize',12);

xlabel('Number of Web browsing sources','FontSize',12);
ylabel('Blocking Probability','FontSize',12);
grid on

%% Ex3
% R = 30E6;
% 
% EL = 8E3;
% B_a = 10E6;
% B_b = 23E6;
% B_c = 15E6;
% B_d = 6E6;
% 
% lambda_a = B_a/EL;
% lambda_b = B_b/EL;
% lambda_c = B_c/EL;
% lambda_d = B_d/EL;
% 
% dprocessing = 0;
% dpropagation = 1E-3;
% 
% % for flow A: path A->R1->R3->R4->D
% D_R1toR3 = HopDelay(R,lambda_a,EL,dprocessing,dpropagation);
% D_R3toR4 = HopDelay(R,lambda_a,EL,dprocessing,dpropagation);
% D_R4toD = HopDelay(R,lambda_a,EL,dprocessing,dpropagation);
% De2e_a = dpropagation + D_R1toR3 + D_R3toR4 + D_R4toD
% 
% % for flow B: path B->R2->R4->C
% D_R2toR4 = HopDelay(R,lambda_b,EL,dprocessing,dpropagation);
% D_R4toC = HopDelay(R,lambda_b + lambda_d,EL,dprocessing,dpropagation);
% De2e_b = dpropagation + D_R2toR4 + D_R4toC
% 
% % for flow C: path C->R4->R3->R1->A
% D_R4toR3 = HopDelay(R,lambda_c,EL,dprocessing,dpropagation);
% D_R3toR1 = HopDelay(R,lambda_c,EL,dprocessing,dpropagation);
% D_R1toA =  HopDelay(R,lambda_c,EL,dprocessing,dpropagation);
% De2e_c = dpropagation + D_R4toR3 + D_R3toR1 + D_R1toA
% 
% % for flow D: path D->R4->C
% D_R4toC= HopDelay(R,lambda_b + lambda_d,EL,dprocessing,dpropagation);
% De2e_d = dpropagation + D_R4toC





