
% Input:
% -- lambda: arrival rate (poisson)
% -- EDs: expected service time (expo)
% -- K: max number of elements in the system
% Outputs:
% -- System delay
% -- Buffer delay
% -- Blocking Probability
% -- Queue utilization (Prob the system is busy)

function [ED,EDq,Pb,rho]=mm1k(lambda,EDs,K)

a = lambda * EDs;

mu = 1 / EDs;

if(a==1)
   EN = K/2; 
   Pb = 1 /(K+1);
else
   EN = a/(1-a) - (K+1)*a^(K+1)/(1-a^(K+1));
   Pb = (1-a)*a^K / (1-a^(K+1));
end

ED = EN/(lambda*(1-Pb));
EDq = ED - EDs;
rho = a * (1-Pb);

end
