clear 
clc
%% EX1
%Q1
lambda1 = 4000;
lambda2 = 1000;
lambda3 = 4000;
lambda4 = 100;

EL1 = 100;
EL2 = 2000;
EL3 = 4000;
EL4 = 12000;

CV1 = 0.5;
CV2 = 2;
CV3 = 1;
CV4 = 0;

[ED1,ED2,ED3,ED4] = mg1APmodel(lambda1,lambda2,lambda3,lambda4,EL1,EL2,EL3,EL4,CV1,CV2,CV3,CV4)

%Q2

CV4 = 0:1:20;
n = length(CV4);
ED1 = zeros(1,n);
ED2 = zeros(1,n);
ED3 = zeros(1,n);
ED4 = zeros(1,n);

for i=1:n
   [ED1(i),ED2(i),ED3(i),ED4(i)]=mg1APmodel(lambda1,lambda2,lambda3,lambda4,EL1,EL2,EL3,EL4,CV1,CV2,CV3,CV4(i));
end

figure('pos',[400 400 450 300])
axes;
set(gca,'fontsize',12);
semilogy(CV4,ED1,'ro-','LineWidth',1.5,'Markersize',8,'Color',[0.2,0.8,0.2]);
hold
semilogy(CV4,ED2,'rx-','LineWidth',1.5,'Markersize',8,'Color',[0.4,0.6,0.2]);
semilogy(CV4,ED3,'rs-','LineWidth',1.5,'Markersize',8,'Color',[0.6,0.4,0.2]);
semilogy(CV4,ED4,'r+-','LineWidth',1.5,'Markersize',8,'Color',[0.8,0.2,0.2]);
hold

h_legend=legend('E[D_1]','E[D_2]','E[D_3]','E[D_4]');
set(h_legend,'FontSize',12);

xlabel('CV_4','FontSize',12);
ylabel('seconds','FontSize',12);
axis([min(CV4) max(CV4) 1E-4 0.02]);


%Q3
CV4=0;
lambda4 = 100:50:600;
n = length(lambda4);
ED1 = zeros(1,n);
ED2 = zeros(1,n);
ED3 = zeros(1,n);
ED4 = zeros(1,n);

for i=1:n
   [ED1(i),ED2(i),ED3(i),ED4(i)]=mg1APmodel(lambda1,lambda2,lambda3,lambda4(i),EL1,EL2,EL3,EL4,CV1,CV2,CV3,CV4);
end

figure('pos',[400 400 450 300])
axes;
set(gca,'fontsize',12);
semilogy(lambda4,ED1,'ro-','LineWidth',1.5,'Markersize',8,'Color',[0.2,0.8,0.2]);
hold
semilogy(lambda4,ED2,'rx-','LineWidth',1.5,'Markersize',8,'Color',[0.4,0.6,0.2]);
semilogy(lambda4,ED3,'rs-','LineWidth',1.5,'Markersize',8,'Color',[0.6,0.4,0.2]);
semilogy(lambda4,ED4,'r+-','LineWidth',1.5,'Markersize',8,'Color',[0.8,0.2,0.2]);
hold

h_legend=legend('E[D_1]','E[D_2]','E[D_3]','E[D_4]');
set(h_legend,'FontSize',12);

xlabel('\lambda_4','FontSize',12);
ylabel('seconds','FontSize',12);
axis([min(lambda4) max(lambda4) 1E-4 1]);

%% EX2

lambda1 = 4000;
lambda2 = 1000;
lambda3 = 4000;
lambda4 = 100;

EL1 = 100;
EL2 = 2000;
EL3 = 4000;
EL4 = 12000;

CV1 = 0.5;
CV2 = 2;
CV3 = 1;
CV4 = 0;


R = 26E6;

EDs1=EL1/R
EDs2=EL2/R
EDs3=EL3/R
EDs4=EL4/R

rho1=lambda1*EL1/R
rho2=lambda2*EL2/R
rho3=lambda3*EL3/R
rho4=lambda4*EL4/R     

[ED1_hl,ED2_hl,ED3_hl,ED4_hl] = mg1APmodelprio_h2l(lambda1,lambda2,lambda3,lambda4,EL1,EL2,EL3,EL4,CV1,CV2,CV3,CV4)

[ED1_lh,ED2_lh,ED3_lh,ED4_lh] = mg1APmodelprio_l2h(lambda1,lambda2,lambda3,lambda4,EL1,EL2,EL3,EL4,CV1,CV2,CV3,CV4)



